#!/bin/bash

#Please read Readme-config

function try_python {
	q=`
	echo '
	#include <'$1'Python.h>
int main() {
	Py_Initialize();

	printf("%s", PY_VERSION);
	return 0;
}
	' | test_compile | awk '
	#allow a line that stars with 2.5, 2.4 and 2.3
	/^2.5/ {
		print "OK"
		next
	}
	/^2.4/ {
		print "OK"
		next
	}
	/^2.3/ {
		print "OK"
		next
	}
	# do not allow anything else
	{
		print "wrong"
	}
'`

	echo "[scripts] Trying python with $1, $CFLAGS, $LDFLAGS -> $q" >> $LOG

	if test "$q" = "OK"
	then
		return 0
	fi

	return 1
}

function python_find() {
	if ! test "$with_os" = "windlc"
	then
		flags="-pthread"
	else
		flags="-L/usr/bin -L/usr/local/bin"
	fi
	LDFLAGS="-lPython $flags"
	try_python "" 2>/dev/null  && echo "|" $LDFLAGS && return

	for n in `ls -d /usr/local/include/python* /usr/include/python* 2>/dev/null `
	do
		LDFLAGS=`echo "-l$n" | sed s@/usr.*include/@@`
		LDFLAGS="$LDFLAGS $flags"
		try_python "$n/" 2>/dev/null  && echo -I $n "|" $LDFLAGS && return
		LDFLAGS="-lpython $flags"
		try_python "$n/" 2>/dev/null && echo -I $n "|" $LDFLAGS && return
	done

	# trying to get info from python itself (python executable must be in PATH)
	CFLAGS=`python -c "import distutils.sysconfig; print '-I' + distutils.sysconfig.get_python_inc().replace('\\\\\\\\','/')"`
	LDFLAGS=`python -c "import distutils.sysconfig; print '-L' + distutils.sysconfig.PREFIX.replace('\\\\\\\\','/') + '/libs',; import sys; print '-lpython' + str(sys.version_info[0]) + str(sys.version_info[1])"`
	try_python "" 2>/dev/null && echo "$CFLAGS | $LDFLAGS" && return

	# trying to use windows binaries in default install dir (c:/Python24)
	# set WIN32_PYTHON_ROOT to the path of your python binaries (where is python.exe)
	WIN32_PYTHON_ROOT=c:/Python24
	LDFLAGS=`echo "-L$WIN32_PYTHON_ROOT/libs -lpython24"`
	CFLAGS=`echo "-I$WIN32_PYTHON_ROOT/include"`
	try_python "" 2>/dev/null && echo "$CFLAGS | $LDFLAGS"
}

#remove these before you start using it
. lib/compile.lib
python_find
