#include <gpmi.h>
#include <gpmi/modules.h>
#include "cli.h"

static const GPMI_Script_Info Cli_Proc_Info = {
	&Cli_Initialize,
	&Cli_Destroy,
	&Cli_GetExtension,
	&Cli_RegisterCommand,
	&Cli_LoadScript,
	&Cli_Rehash,
	&Cli_RunFunction,
	0,
};

void gpmi_mod(RunTick)(gpmi_module *module, int frame_counter)
{
	GPMI_Script_RunTick(module, frame_counter);
}

void gpmi_mod(RunData)(gpmi_module *module, void *data)
{
	GPMI_Script_RunData(module, data);
}

/**
 * Run direct Cli command from the console. For debugging.
*/
int gpmi_mod(Debug)(gpmi_module *module, const char *parameters)
{
//	Cli_ClientData *Cli_MyData = module->mod_data;

	return 0;
}

/**
 * Necessarry routines to init/uninit the module
 */
int gpmi_mod(Initialize)(gpmi_module *module, const char *params)
{
	return GPMI_Script_Load(&Cli_Proc_Info, module, params);
}

void gpmi_mod(Uninitialize)(gpmi_module *module)
{
	GPMI_Script_Destroy(module);
}
