#ifndef SCRIPT_MODULE_PYTHON_H
#define SCRIPT_MODULE_PYTHON_H

#include <Python.h>
#include "packages/gpmi_scripts.h"

typedef struct Python_ClientData {
	PyObject *module;
	PyObject *dict;

	PyObject *root_module;
	PyObject *root_dict;
	PyObject *root_class;
} Python_ClientData;

int  Python_Initialize(void **client_data);
void Python_Destroy(void **client_data);
void Python_RegisterCommand(void *client_data, const char *name);
int  Python_LoadScript(void *client_data, const char *filename);
char *Python_GetExtension();
void Python_CallFunction(void *client_data, const char *function, int argc, const char **argv);

void Python_Uninitialize( void );

#endif /* SCRIPT_MODULE_PYTHON_H */
