#include <stdio.h>
#include <stdlib.h>
#include "example.h"

/* Simple routine examples  */
int Example_int(int offset)
{
	return 1234 + offset;
}

/* Simple routine examples  */
unsigned int Example_uint(unsigned int offset)
{
	return 1234 + offset;
}

char *Example_string(int num, char *text)
{
	char *result;

	result = malloc(128);
	snprintf(result, 128, "This is an example string for %d: %s.", num, text);

	return result;
}

/**
 * Example on installing an event. Event name is "Example_event_nothing"
 * and it is triggered whenever you call Example_do_event from your
 * module.
 */
int Example_do_nothing(int param) {
	printf("example-pkg: Doing nothing with param %d\n", param);
	gpmi_event(gpmi_get_current_module(), Example_nothing, 2005, param);
	return 0;
}



/*------ An example on keywords using enums for C -------*/

gpmi_keyword *Example_colors_kw = NULL;

/* Static Keyword Array (ska) that we can import in the init section */
const gpmi_keyword_static_int example_colors_ska[] = {
	{"red", 	example_red},
	{"green", example_green},
	{"blue",	example_blue},
	{NULL, 0}
} ;

/**
 * This function will rotate input color: red->green->blue->red
 * Added for string callings to demonstrate keyword resolves
 * Both input and output are single keywords of type example_colors_kw.
*/
example_colors_t Example_color_rot(example_colors_t color) {
	switch(color) {
		case example_red:		return example_green;
		case example_green:	return example_blue;
		case example_blue:	return example_red;
	}
	return -1;
}

/**
 * This function will calculate the inverse of a color: any component
 * present in the input won't be present in the output and vica versa.
 * Added for string callings to demonstrate multiple keyword resolves
 * Both input and output are multiple keywords of type example_colors_kw.

*/
example_colors_t Example_color_inv(example_colors_t color) {
	return (color ^ (example_red | example_green | example_blue));
}
