#ifndef MODULE_EVENTS_H
#define MODULE_EVENTS_H
typedef struct module_event module_event;

typedef void module_events_callback(void *handle, void *event_data);
typedef void module_free_data_proc(void *data); //! Called to free the 'event_data' from module_events_call
typedef int  module_compare_data_proc(void *data1, void *data2); //! Called from unbind, to check if 2 event_data's are the same

/* Each module id has a signle linked list of event data */
struct module_event {
	void *data;
	module_event *next;
	int called;
} ;

/* Structure to store all the events */
typedef struct module_events {
	module_event **events;
	int allocated;
} module_events;

module_events *module_events_init();
int module_events_uninit(module_events *events, module_free_data_proc *proc);
void module_events_bind(module_events *events, int event_id, void *event_data);
int module_events_unbind(module_events *events, int event_id, void *event_data, module_compare_data_proc *proc_match, module_free_data_proc *proc);
int module_events_call(module_events *events, int event_id, module_events_callback *callback, void *handle);
#endif /* MODULE_EVENTS_H */
