-- This is an example how to use hash package from lua. This script is 
-- also part of the regression test

PkgLoad("hash", 0)

hash = gpmi_hash_create(8)
io.write("table: ", hash, " != 0\n")

io.write("Recno: ", gpmi_hash_stat_recno(hash), "\n")

gpmi_hash_store(hash, "red", "R")
gpmi_hash_store(hash, "green", "G")
gpmi_hash_store(hash, "blue", "B")

io.write("Recno: ", gpmi_hash_stat_recno(hash), " == 3\n")

io.write("max records per node: ", gpmi_hash_stat_max_node(hash), "\n")
io.write("avg records per node: ", gpmi_hash_stat_avg_node(hash), "\n")
io.write("memory: ", gpmi_hash_stat_mem(hash), " bytes are wasted\n")

io.write("Red is ", gpmi_hash_find(hash, "red"), " == R\n")

io.write("Now a rehash...\n")
hash = gpmi_hash_rehash(hash, 256)
io.write("table: ", hash, " != 0x0\n")

io.write("max records per node: ", gpmi_hash_stat_max_node(hash), "\n")
io.write("avg records per node: ", gpmi_hash_stat_avg_node(hash), "\n")
io.write("memory: ", gpmi_hash_stat_mem(hash), " bytes are wasted\n")

io.write("Green is ", gpmi_hash_find(hash, "green"), " == G\n")

