#include <stdlib.h>
#include <string.h>
#include "str_buff.h"

str_buff_t *str_buff_open()
{
	str_buff_t *b;

	b = malloc(sizeof(str_buff_t));

	b->buff      = NULL;
	b->allocated = 0;
	b->used      = 0;

	return b;
}

void str_buff_add(str_buff_t *b, char *s, int len)
{
	int u;

	u = b->used + len;

	if (u >= b->allocated) {
		b->allocated = u + 1024;
		b->buff = realloc(b->buff, b->allocated);
	}

	memcpy(b->buff + b->used, s, len);
	b->buff[u] = '\0';

	b->used = u;
}

void str_buff_print(FILE *f, str_buff_t *b)
{
	fprintf(f, "%s", b->buff);
}

void str_buff_close(str_buff_t *b)
{
	if (b->buff != NULL)
		free(b->buff);
	free(b);
}
