#include "wrapgen_keywords.h"

hash_t *keywords = NULL;

/* Warning: multiline macro! */
#define Warning(x...)		fprintf(stderr, "Warning: "); fprintf(stderr, x);

void keyword_init()
{
	keywords = hash_create(128, NULL);
}

int keyword_store(char *name, char *type_)
{
	const int *type;
	int *temp;
	int type_tmp;

	type_tmp = FindType(type_);
	if (type_tmp == type_keyword) {
		Warning("Invalid type for keyword %s: %s\n", name, type_);
		return -1;
	}

	type = hash_find(keywords, name);
	if (type != NULL) {
		if (*type != type_tmp) {
			Warning("Redefinition of keyword %s for a different type\n", name);
		}
		else {
			Warning("Redefinition of keyword %s\n", name);
		}
		return 2;
	}

	temp = malloc(4);
	*temp = type_tmp;
	hash_store(keywords, name, temp);
	return 0;
}

int keyword_find(char *name)
{
	const int *type;

	type = hash_find(keywords, name);

	if (type == NULL)
		return -1;

	return *type;
}
